clear all
close all

pos_s=dlmread('coord_S.xvg','',66,1);

%%vector each frame
for t=1:9001
    x1=pos_s(t,1)+pos_s(t,4)+pos_s(t,7)+pos_s(t,10)+pos_s(t,25)+pos_s(t,28)+pos_s(t,31)+pos_s(t,34);
    y1=pos_s(t,2)+pos_s(t,5)+pos_s(t,8)+pos_s(t,11)+pos_s(t,26)+pos_s(t,29)+pos_s(t,32)+pos_s(t,35);
    z1=pos_s(t,3)+pos_s(t,6)+pos_s(t,9)+pos_s(t,12)+pos_s(t,27)+pos_s(t,30)+pos_s(t,33)+pos_s(t,36);
    x2=pos_s(t,13)+pos_s(t,16)+pos_s(t,19)+pos_s(t,22)+pos_s(t,37)+pos_s(t,40)+pos_s(t,43)+pos_s(t,46);
    y2=pos_s(t,14)+pos_s(t,17)+pos_s(t,20)+pos_s(t,23)+pos_s(t,38)+pos_s(t,41)+pos_s(t,44)+pos_s(t,47);
    z2=pos_s(t,15)+pos_s(t,18)+pos_s(t,21)+pos_s(t,24)+pos_s(t,39)+pos_s(t,42)+pos_s(t,45)+pos_s(t,48);
    vector{t}=[x2/8-x1/8,y2/8-y1/8,z2/8-z1/8];
end

for t=1:9001
    chain1_end1{t}=[pos_s(t,1)+pos_s(t,4),pos_s(t,2)+pos_s(t,5),pos_s(t,3)+pos_s(t,6)]/2;
    chain1_end2{t}=[pos_s(t,19)+pos_s(t,22),pos_s(t,20)+pos_s(t,23),pos_s(t,21)+pos_s(t,24)]/2;
    chain2_end1{t}=[pos_s(t,25)+pos_s(t,28),pos_s(t,26)+pos_s(t,29),pos_s(t,27)+pos_s(t,30)]/2;
    chain2_end2{t}=[pos_s(t,43)+pos_s(t,46),pos_s(t,44)+pos_s(t,47),pos_s(t,45)+pos_s(t,48)]/2;
end
for t=1:9001
    temp1=sum([chain1_end1{t}-chain1_end2{t}].*vector{t})/sqrt(vector{t}(1)^2+vector{t}(2)^2+vector{t}(3)^2);
    temp2=sum([chain2_end1{t}-chain2_end2{t}].*vector{t})/sqrt(vector{t}(1)^2+vector{t}(2)^2+vector{t}(3)^2);
    temp3=sum([chain1_end1{t}-chain2_end2{t}].*vector{t})/sqrt(vector{t}(1)^2+vector{t}(2)^2+vector{t}(3)^2);
    temp4=sum([chain2_end1{t}-chain1_end2{t}].*vector{t})/sqrt(vector{t}(1)^2+vector{t}(2)^2+vector{t}(3)^2);
    distance(t)=max([abs(temp1),abs(temp2),abs(temp3),abs(temp4)]);
end

figure(1);
plot([30000:10:120000]/1000,distance,'linewidth',2);
xlabel('Time (ns)')
ylabel('Distance between top & bottom sulfonate units (nm)');
ylim([4.4,5.6])
xlim([30,120])
plot_style(15)
print('-dpng','-r300','chain_length_30ns.png')


for t=1:9001
    vector1=chain1_end1{t}-chain1_end2{t};
    temp11(t)=sqrt(vector1(1)^2+vector1(2)^2+vector1(3)^2);
    vector2=chain2_end1{t}-chain2_end2{t};
    temp21(t)=sqrt(vector2(1)^2+vector2(2)^2+vector2(3)^2);
    vector3=chain1_end1{t}-chain2_end2{t};
    temp31(t)=sqrt(vector3(1)^2+vector3(2)^2+vector3(3)^2);
    vector4=chain2_end1{t}-chain1_end2{t};
    temp41(t)=sqrt(vector4(1)^2+vector4(2)^2+vector4(3)^2);
    distance_max(t)=max([temp11(t),temp21(t),temp31(t),temp41(t)]);
end
figure(2);
plot([30000:10:120000]/1000,temp11,'linewidth',2);
xlabel('Time (ns)')
ylabel('Distance between top & bottom sulfonate units (nm)');
ylim([4.4,5.6])
xlim([30,120])
plot_style(15)

figure(3);
plot([30000:10:120000]/1000,temp21,'linewidth',2);
xlabel('Time (ns)')
ylabel('Distance between top & bottom sulfonate units (nm)');
ylim([4.4,5.6])
xlim([30,120])
plot_style(15)

figure(4);
plot([30000:10:120000]/1000,temp31,'linewidth',2);
xlabel('Time (ns)')
ylabel('Distance between top & bottom sulfonate units (nm)');
ylim([4.4,5.6])
xlim([30,120])
plot_style(15)

figure(5);
plot([30000:10:120000]/1000,temp41,'linewidth',2);
xlabel('Time (ns)')
ylabel('Distance between top & bottom sulfonate units (nm)');
ylim([4.4,5.6])
xlim([30,120])
plot_style(15)
print('-dpng','-r300','chain_length_30ns_new.png')

figure(6);
plot([30000:10:120000]/1000,distance_max,'linewidth',2);
xlabel('Time (ns)')
ylabel('Distance between top & bottom sulfonate units (nm)');
ylim([4.4,5.6])
xlim([30,120])
plot_style(15)

%%%distance between two SO3 units 2-6 & 2-7
for t=1:9001
    n2{t}=[pos_s(t,7)+pos_s(t,10),pos_s(t,8)+pos_s(t,11),pos_s(t,9)+pos_s(t,12)]/2;
    n6{t}=[pos_s(t,31)+pos_s(t,34),pos_s(t,32)+pos_s(t,35),pos_s(t,33)+pos_s(t,36)]/2;
    n7{t}=[pos_s(t,37)+pos_s(t,40),pos_s(t,38)+pos_s(t,41),pos_s(t,39)+pos_s(t,42)]/2;
end

for t=1:9001
    temp26=sum([n2{t}-n6{t}].*vector{t})/sqrt(vector{t}(1)^2+vector{t}(2)^2+vector{t}(3)^2);
    temp27=sum([n2{t}-n7{t}].*vector{t})/sqrt(vector{t}(1)^2+vector{t}(2)^2+vector{t}(3)^2);
    distance2_6(t)=abs(temp26);
    distance2_7(t)=abs(temp27);
end
figure(7);
plot([30000:10:120000]/1000,distance2_6,'linewidth',2);
xlabel('Time (ns)')
ylabel('Distance between two sulfonate units (nm)');
%ylim([4.4,5.6])
xlim([30,120])
plot_style(15)
print('-dpng','-r300','sulfonate26.png')

figure(8);
plot([30000:10:120000]/1000,distance2_7,'linewidth',2);
xlabel('Time (ns)')
ylabel('Distance between two sulfonate units (nm)');
%ylim([4.4,5.6])
xlim([30,120])
plot_style(15)
print('-dpng','-r300','sulfonate27.png')